"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Paths = exports.userConfig = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _path = _interopRequireDefault(require("path"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function getUserConfigFile() {
  try {
    // eslint-disable-next-line import/no-dynamic-require, global-require
    return require(_path["default"].join(process.cwd(), 'cypress-image-diff.config'));
  } catch (err) {
    return {};
  }
}

var DEFAULT_CONFIG = {
  ROOT_DIR: '',
  FAILURE_THRESHOLD: 0,
  RETRY_OPTIONS: {},
  FAIL_ON_MISSING_BASELINE: false,
  COMPARISON_OPTIONS: {
    threshold: 0.1
  }
};

var userConfig = _objectSpread(_objectSpread({}, DEFAULT_CONFIG), getUserConfigFile());

exports.userConfig = userConfig;

var Paths = /*#__PURE__*/function () {
  function Paths() {
    (0, _classCallCheck2["default"])(this, Paths);
    this.rootDir = userConfig.ROOT_DIR;
    this.screenshotFolderName = 'cypress-visual-screenshots';
    this.reportFolderName = 'cypress-visual-report';
  }

  (0, _createClass2["default"])(Paths, [{
    key: "report",
    value: function report(instance) {
      return _path["default"].join(this.reportDir, "cypress-visual-report".concat(instance, ".html"));
    }
  }, {
    key: "screenshotDir",
    get: function get() {
      return _path["default"].join(this.rootDir, this.screenshotFolderName);
    }
  }, {
    key: "baseline",
    get: function get() {
      return _path["default"].join(process.cwd(), this.screenshotDir, 'baseline');
    }
  }, {
    key: "comparison",
    get: function get() {
      return _path["default"].join(process.cwd(), this.screenshotDir, 'comparison');
    }
  }, {
    key: "diff",
    get: function get() {
      return _path["default"].join(process.cwd(), this.screenshotDir, 'diff');
    }
  }, {
    key: "image",
    get: function get() {
      var _this = this;

      return {
        baseline: function baseline(testName) {
          return _path["default"].join(_this.baseline, "".concat(testName, ".png"));
        },
        comparison: function comparison(testName) {
          return _path["default"].join(_this.comparison, "".concat(testName, ".png"));
        },
        diff: function diff(testName) {
          return _path["default"].join(_this.diff, "".concat(testName, ".png"));
        }
      };
    }
  }, {
    key: "dir",
    get: function get() {
      return {
        baseline: this.baseline,
        comparison: this.comparison,
        diff: this.diff
      };
    }
  }, {
    key: "reportDir",
    get: function get() {
      return _path["default"].join(process.cwd(), this.rootDir, this.reportFolderName);
    }
  }]);
  return Paths;
}();

exports.Paths = Paths;

var _default = new Paths();

exports["default"] = _default;